<?php
	header('Content-Type: text/html; charset=utf-8');
	include './standalone.php';
	
	$types_coll = umiObjectTypesCollection::getInstance();
	//Получаем id типа данных "Заказ"
	$order_type_id = $types_coll->getBaseType('emarket', 'order');
	$order_type = $types_coll->getType($order_type_id);
	//Получаем id типа данных "Товар в заказе"
	$ord_item_type_id = $types_coll->getBaseType('emarket', 'order_item');
	//Получаем id типа данных "Незарегистрированный покупатель"
	$cust_type_id = $types_coll->getBaseType('emarket', 'customer');
	//Получаем id поля "customer_id"
	$cust_field_id = $order_type->getFieldId('customer_id');
	//Получаем id поля "order_items"
	$ord_items_field_id = $order_type->getFieldId('order_items');
	
	if (getRequest('load')=='1'){
		get_num_objects();
		die();
	}
	
	do_clean();
	
	function do_clean(){
		$func = getRequest('func');
		if (!$func)
			return false;
		switch ($func){
			case 'orders_gen':{
				echo del_objects(get_orders_fordel_gen());
				break;
			}
			case 'orders':{
				echo del_objects(get_orders_fordel());
				break;
			}
			case 'order_items':{
				echo del_objects(get_order_items_fordel());
				break;
			}
			case 'customers':{
				echo del_objects(get_customers_fordel());
				break;
			}
		}
	}
	//Возвращает массив id недооформленных заказов, в которых нет товаров
	function get_orders_fordel_gen(){
		global $order_type_id, $ord_items_field_id;
		$offset = getRequest('offset') ? getRequest('offset') : 0;
		$length = getRequest('length') ? getRequest('length') : 5000;
		
		$orders_query = "SELECT `id` FROM `cms3_objects` WHERE ";
		$orders_query.= "`name` IS NULL AND `type_id` = {$order_type_id} LIMIT {$offset}, {$length}";
		
		$orders_arr = result_query($orders_query);
		
		$res_array = array();
		foreach($orders_arr as $order_id){
			$found_arr = array();
			$sql = "SELECT `obj_id` FROM `cms3_object_content` WHERE `obj_id`= {$order_id} AND ";
			$sql.= "`field_id` = {$ord_items_field_id} AND `rel_val` IS NOT NULL";
			$res = mysql_query($sql);
			while($row = mysql_fetch_row($res))
				$found_arr[] = $row;
			if (empty($found_arr))
				$res_array[] = $order_id;
		}
		return $res_array;
	}
	
	//Возвращает массив id заказов, у которых нет покупателя
	function get_orders_fordel(){
		global $order_type_id, $cust_field_id;
		$offset = getRequest('offset') ? getRequest('offset') : 0;
		$length = getRequest('length') ? getRequest('length') : 5000;
		
		$orders_query = "SELECT `id` FROM `cms3_objects` WHERE (`name` != 'dummy' OR ";
		$orders_query.= "`name` IS NULL) AND `type_id` = {$order_type_id} LIMIT {$offset}, {$length}";
		
		$orders_arr = result_query($orders_query);
		
		$res_array = array();
		foreach($orders_arr as $order_id){
			$sql = "SELECT `obj_id` FROM `cms3_object_content` WHERE `obj_id`= {$order_id} AND ";
			$sql.= "`field_id` = {$cust_field_id} AND `rel_val` IS NULL";
			$res = mysql_query($sql);
			while($row = mysql_fetch_row($res))
			$res_array[] = $row[0];
		}
		return $res_array;
	}
	
	//Возвращает массив id товаров в заказе, которых нет ни в одном заказе
	function get_order_items_fordel(){
		global $ord_item_type_id, $ord_items_field_id;
		$offset = getRequest('offset') ? getRequest('offset') : 0;
		$length = getRequest('length') ? getRequest('length') : 5000;
		
		$ord_items_query = "SELECT `id` FROM `cms3_objects` WHERE ";
		$ord_items_query.= "`type_id` = {$ord_item_type_id} LIMIT {$offset}, {$length}";
		
		$ord_items_arr = result_query($ord_items_query);
		
		$res_array = array();
		
		foreach($ord_items_arr as $ord_item_id){
			$found_arr = array();
			$sql = "SELECT obj_id FROM `cms3_object_content` WHERE `field_id`= ";
			$sql.= "{$ord_items_field_id} AND `rel_val` = {$ord_item_id}";
			
			$res = mysql_query($sql);
			while($row = mysql_fetch_row($res))
				$found_arr[] = $row;
			if (empty($found_arr))
				$res_array[] = $ord_item_id;
		}
		return $res_array;
		
	}
	
	//Возвращает массив id покупателей, которые не указаны ни для одного заказа
	function get_customers_fordel(){
		global $cust_type_id, $cust_field_id;
		$offset = getRequest('offset') ? getRequest('offset') : 0;
		$length = getRequest('length') ? getRequest('length') : 5000;
		
		$customers_query = "SELECT `id` FROM `cms3_objects` WHERE ";
		$customers_query.= "`type_id` = {$cust_type_id} LIMIT {$offset}, {$length}";
		
		$customers_arr = result_query($customers_query);
		
		$res_array = array();
		foreach($customers_arr as $customer_id){
			$found_arr = array();
			$sql = "SELECT obj_id FROM `cms3_object_content` WHERE `field_id`= ";
			$sql.= "{$cust_field_id} AND `rel_val` = {$customer_id}";
			
			$res = mysql_query($sql);
			while($row = mysql_fetch_row($res))
				$found_arr[] = $row;
			if (empty($found_arr))
				$res_array[] = $customer_id;
		}
		return $res_array;
	}
	
	function get_num_objects(){
		if (!$func = getRequest('func'))
			return 0;
		switch ($func){
			case 'orders_gen':{
				echo num_orders_gen();
				break;
			}
			case 'orders':{
				echo num_orders();
				break;
			}
			case 'order_items':{
				echo num_order_items();
				break;
			}
			case 'customers':{
				echo num_customers();
				break;
			}
		}
		
	}
	function num_orders_gen(){
		global $order_type_id;
		$orders_query = "SELECT count(`id`) FROM `cms3_objects` WHERE ";
		$orders_query.= "`name` IS NULL AND `type_id` = {$order_type_id}";
		
		$total = result_query($orders_query);
		return $total[0];
	}
	function num_orders(){
		global $order_type_id;
		$orders_query = "SELECT count(`id`) FROM `cms3_objects` WHERE (`name` != 'dummy' OR ";
		$orders_query.= "`name` IS NULL) AND `type_id` = {$order_type_id}";
		
		$total = result_query($orders_query);
		return $total[0];
	}
	function num_order_items(){
		global $ord_item_type_id;
		$ord_items_query = "SELECT count(`id`) FROM `cms3_objects` WHERE ";
		$ord_items_query.= "`type_id` = {$ord_item_type_id}";
		
		$total = result_query($ord_items_query);
		return $total[0];
	}
	function num_customers(){
		global $cust_type_id;
		$customers_query = "SELECT count(`id`) FROM `cms3_objects` WHERE ";
		$customers_query.= "`type_id` = {$cust_type_id}";
		
		$total = result_query($customers_query);
		return $total[0];
	}
	
	function result_query($query){
		$res = mysql_query($query);
		
		$result_arr = array();
		while($row = mysql_fetch_row($res))
			$result_arr[] = $row[0];
		return $result_arr;
	}
	
	//Удаляет объекты по id из массива $obj_array
	//Возвращает количество удаленных объектов
	function del_objects($obj_array){
		$objColl = umiObjectsCollection::getInstance();
		$count = 0;
		foreach ($obj_array as $obj_id){
			if (is_numeric($obj_id)){
				$succ = $objColl->delObject($obj_id);
				if ($succ)
					$count++;
			}
		}
		return $count;
	}
	
?>
